[bat]
BAT_BISECTION_OLD=d012a7190fc1fd72ed48911e77ca97ba4521bccd
BAT_BISECTION_NEW=3a00d3dfd4b68b208ecd5405e676d06c8ad6bb63
BAT_GIT_DIR=/srv/jenkins/kernel/bisecting-2

[build]
#for p in ${BAT_GIT_DIR}/mypatches-v2/*.patch; do
#  git -C "${BAT_GIT_DIR}" am --3way ${p} || git -C "${BAT_GIT_DIR}" am --skip
#done
#git -C "${BAT_GIT_DIR}" push -f own HEAD:my-test-branch
## I need a NEW_SHA since I apply my own crap...
#NEW_SHA=$(git -C "${BAT_GIT_DIR}" rev-parse HEAD)

# Build kernel using Tuxbuild
tuxbuild build --git-repo https://git.kernel.org/pub/scm/linux/kernel/git/next/linux-next.git \
  --target-arch arm \
  --toolchain gcc-9 \
  --json-out build.json \
  --kconfig defconfig \
  --kconfig https://raw.githubusercontent.com/Linaro/meta-lkft/sumo/recipes-kernel/linux/files/lkft.config \
  --kconfig https://raw.githubusercontent.com/Linaro/meta-lkft/sumo/recipes-kernel/linux/files/lkft-crypto.config \
  --kconfig https://raw.githubusercontent.com/Linaro/meta-lkft/sumo/recipes-kernel/linux/files/distro-overrides.config \
  --kconfig https://raw.githubusercontent.com/Linaro/meta-lkft/sumo/recipes-kernel/linux/files/systemd.config \
  --kconfig https://raw.githubusercontent.com/Linaro/meta-lkft/sumo/recipes-kernel/linux/files/virtio.config \
  --kconfig https://raw.githubusercontent.com/Linaro/meta-lkft/sumo/recipes-kernel/linux/files/multi_v7_hugepage.config \
  --kconfig CONFIG_ARM_TI_CPUFREQ=y \
  --kconfig CONFIG_SERIAL_8250_OMAP=y \
  --kconfig CONFIG_POSIX_MQUEUE=y \
  --git-sha ${BAT_KERNEL_SHA}

#  --git-sha ${NEW_SHA}


build_ret=$?

build_json=build.json

GIT_DESCRIBE="$(jq -r .git_describe "${build_json}")"
DOWNLOAD_URL="$(jq -r .download_url "${build_json}")"
# The URL ends with /, so remove the last one
DOWNLOAD_URL="$(echo "${DOWNLOAD_URL}" | cut -d/ -f1-4)"
KERNEL_NAME=$(curl -sSL ${DOWNLOAD_URL}/bmeta.json|jq -r .kernel_image)
MODULES_NAME=$(curl -sSL ${DOWNLOAD_URL}/bmeta.json|jq -r .modules)

export BAT_PUB_URL="${DOWNLOAD_URL}"
export BAT_LAVA_JOBNAME="lkft-bisection x15 BUG ${BAT_BISECTION_NEW} ${GIT_DESCRIBE}"
export BAT_PUB_KERNEL="${DOWNLOAD_URL}/${KERNEL_NAME}"
export BAT_PUB_MODULES="${DOWNLOAD_URL}/${MODULES_NAME}"
export BAT_PUB_MODULES_COMPRESSION="xz"


# This is the same for all lava jobs
####################################
[test]
# Write out LAVA job
rm -f job.yaml
eval "cat << EOF
$(cat <(bat_get_section lavajob))
" > job.yaml 2> /dev/null

LAVAJOB=$(lavacli jobs submit job.yaml)
LAVA_LOG="log-${BAT_KERNEL_SHA_SHORT}"
lavacli jobs show ${LAVAJOB}
lavacli jobs wait ${LAVAJOB}
lavacli jobs logs ${LAVAJOB} > ${LAVA_LOG}
####################################

[discriminator]
# Look for specific message in the log:
if grep -qa 'dev_pm_opp_set_rate' ${LAVA_LOG}; then
  echo " ****************************************************** "
  echo " JOB FAILED!"
  echo " ****************************************************** "
  echo " See ${LAVA_LOG}".
  bat_new
else
  echo " ****************************************************** "
  echo " All fine and dandy."
  echo " ****************************************************** "
  echo " See ${LAVA_LOG}".
  bat_old
fi

[lavajob]
timeouts:
  job:
    minutes: 15
  connection:
    minutes: 2
  actions:
    finalize:
      seconds: 60
context:
  test_character_delay: 10
reboot_to_fastboot: true
device_type: x15
job_name: ${BAT_LAVA_JOBNAME}
priority: 99
visibility: public
metadata:
  maybe-metadata: unknown
actions:
- deploy:
    timeout:
      minutes: 40
    to: downloads
    images:
      kernel:
        url: ${BAT_PUB_KERNEL}
      dtb:
        url: ${BAT_PUB_URL}/dtbs/am57xx-beagle-x15.dtb
      modules:
        url: ${BAT_PUB_MODULES}
        compression: ${BAT_PUB_MODULES_COMPRESSION}
      super:
        url: https://storage.lkft.org/rootfs/oe-sumo/20200723/am57xx-evm/rpb-console-image-lkft-am57xx-evm-20200723162735-41.rootfs.ext4.gz
        compression: gz
        apply-overlay: true
    os: oe
    postprocess:
      docker:
        image: roxell/kir
        steps:
        - /kir/lava/board_setup.sh x15
- deploy:
    timeout:
      minutes: 40
    to: fastboot
    docker:
      image: roxell/kir
    images:
      super:
        url: downloads://rpb-console-image-lkft.rootfs.img
        apply-overlay: true
    os: oe
- boot:
    docker:
      image: roxell/kir
    commands:
    - setenv fdtfile am57xx-beagle-x15.dtb
    - setenv console ttyS2,115200n8
    - setenv mmcdev 1
    - part number mmc 1 super part_num
    - setenv bootpart 1:${part_num}
    - run mmcboot
    auto_login:
      login_prompt: 'login:'
      username: root
      password_prompt: ''
      password: ''
    prompts:
    - root@(.*):[/~]#
    timeout:
      minutes: 15
    method: u-boot
- test:
    timeout:
      minutes: 2
    definitions:
    - from: inline
      repository:
        metadata:
          format: Lava-Test Test Definition 1.0
          name: prep-tmp-disk
          description: Mount local disk for tmp space
        run:
          steps:
          - export STORAGE_DEV=$(lava-target-storage SATA || lava-target-storage USB)
          - test -n "${STORAGE_DEV}" || lava-test-raise "STORAGE_DEV not found; job
            exit"
          - echo "y" | mkfs -t ext4 ${STORAGE_DEV} || lava-test-raise "mkfs -t ext4
            ${STORAGE_DEV} failed; job exit"
          - mkdir -p /scratch
          - mount ${STORAGE_DEV} /scratch && echo "mounted" || lava-test-raise "mount
            ${STORAGE_DEV} failed; job exit"
          - df -h
          - mount
      name: prep-tmp-disk
      path: inline/prep.yaml
